#!/bin/bash

# This script accepts a username and signal name on the
# command line and kills the jobs owned by that user using
# the given signal.
prog=${0##*/}
USAGE="Usage:  $prog -u username [-s name] [-n num] [-v]"

# Exit codes are:
#   1	Invalid option
#   2	Invalid username
#   3	Invalid signal name

username=""
signalopt="-s TERM"
no_exec=""

while getopts u:s:n:v opt
do
    case "$opt" in
    u)	username="$OPTARG" ;;
    s)	signalopt="-s $OPTARG" ;;
    n)	signalopt="-n $OPTARG" ;;
    v)	no_exec="echo" ;;
    *)	echo >&2 "Invalid option: '-$opt'"
	echo >&2 "$USAGE"
	exit 1 ;;
    esac
done
shift $(( OPTIND-1 ))

if [[ "$username" == "" ]]; then
    echo >&2 "$USAGE"
    exit 2
fi

# Why are there no quotes around $no_exec?
ps -u "$username" -o pid= | xargs $no_exec kill $signalopt
